<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

// ф-я возвращает файлы пользователя с инфой об их использовании, отсортированные заданным образом
function get_userfiles($comusers_id=0 , $subdir='userfile' , $sort=1 , $no_use=false , $only_use=false , $count=0)
// sort: 1-дата, 2-дата обратно, 3-использован, 4-использован обратно, 5-имя, 6-имя обратно
{
  $key_cache = 'get_userfiles_' . $comusers_id;
  if ($no_use) $key_cache .= '-use';
  if ($only_use) $key_cache .= '-only';
  if ($count) $key_cache .= $count;
 
  if ( $result = mso_get_cache($key_cache) ) 
  {
    $sort_fn = 'uploads_sort_' . $sort;    
    if (function_exists($sort_fn)) uasort($result , $sort_fn);	 
	return $result; // да есть в кэше
  }	  

 
	$CI = & get_instance();
	$CI->load->helper('file'); // хелпер для работы с файлами
	$CI->load->helper('directory');
	$CI->load->helper('form');

	$uploads_url = getinfo('uploads_url');
	$subpath = $subdir . '/' . $comusers_id . '/';
	$path = getinfo('uploads_dir') . $subpath;
    $fn_mso_descriptions = $path . '_mso_i/_mso_descriptions.dat';
 
    $pag = false; // задел
 
	// все файлы в массиве $dirs
	$dirs = directory_map($path, true); // только в текущем каталоге
	if (!$dirs) $dirs = array();

    // создадим массив файлов в текущей директории
    $result = array();


	foreach ($dirs as $file)
	{
		// ключ = время.файл чтобы учесть одно и тоже время разных файлов 
		//$file[filemtime($uploads_dir . '/' . $file) . $file] = $file;		
		
	    $file_full_path = $path . $file;
	  
		if (@is_dir($file_full_path)) continue; // это каталог
		if ($file == 'avatar.jpg') continue; // это служебный файл
    
        $user_file = array('file'=>$file);
    
	   // определим где использовалось в форуме
       $user_file['use'] = array();
    
	if (!$no_use)   
	{	
	// для форума	    
    if ($CI->db->table_exists('dcomments'))
    {
	   $CI->db->select('comment_id , comment_date_create , ddiscussions.discussion_id , ddiscussions.discussion_title');
	   $CI->db->join('ddiscussions', 'ddiscussions.discussion_id = dcomments.comment_discussion_id');
	   $CI->db->where('ddiscussions.discussion_approved', '1');
       $CI->db->where('comment_approved', '1');	
       $CI->db->where('comment_deleted', '0');   	   
   	   $CI->db->where('ddiscussions.discussion_private', '0');   
       $CI->db->where('comment_creator_id', $comusers_id);   	   
	   $CI->db->where(
		'(`comment_content` LIKE \'%' . $CI->db->escape_str($file) . '%\')', '', false);
	   $CI->db->order_by('comment_id', 'desc');

	   $query = $CI->db->get('dcomments');
       
  	   if ($query and ($query->num_rows() > 0) )
	   {
		  foreach ($query->result_array() as $comment)
		  {
		     $user_file['use'][] = array(
			    'title'=>$commen['discussion_title'], 
				'link'=>'goto/disc/' . $comment['discussion_id'] . '/comm/' . $comment['comment_id'],
				't' => 1
				
			  );
		  }	 
	   }
    }

	// для комментариев	
    // комментарии, где использовался файл    
	   $CI->db->select('page.page_id, page.page_slug, page.page_title, comments.*');
       $CI->db->where('comments.comments_approved', '1');
       $CI->db->where('page.page_status', 'publish');	   
	   $CI->db->where($CI->db->dbprefix . 'page.page_id', $CI->db->dbprefix . 'comments.comments_page_id', false);	  
       $CI->db->where('comments.comments_comusers_id', $comusers_id);   	   
	   $CI->db->where(
		'(`comments_content` LIKE \'%' . $CI->db->escape_str($file) . '%\')', '', false);
	   $CI->db->from('comments, page');

       $query = $CI->db->get();  
	   
  	   if ($query and ($query->num_rows() > 0) )
	   {
		  foreach ($query->result_array() as $comment)
		  {
		     $user_file['use'][] = array(
			     'title'=>$comment['page_title'], 
				 'link'=>'page/' . $comment['page_slug'] . '#comment-' . $comment['comments_id'],
				 't' => 0
				);
		  }	 
	   }
	}
		if ($only_use and !$user_file['use']) continue;
 
        // дата файла
        $user_file['date'] = date ("Y-m-d H:i:s" , filemtime($file_full_path));

    $result[] = $user_file;
  }  

  mso_add_cache($key_cache, $result);
  
  $sort_fn = 'uploads_sort_' . $sort;    
  if (function_exists($sort_fn)) uasort($result , $sort_fn);

  return $result;
}


function uploads_sort_1($a, $b) //date
{
	if ( $a['date'] == $b['date'] ) return 0;
	return ( $a['date'] < $b['date'] ) ? 1 : -1;
}

function uploads_sort_2($a, $b) //date обратно
{
	if ( $a['date'] == $b['date'] ) return 0;
	return ( $a['date'] > $b['date'] ) ? 1 : -1;
}

function uploads_sort_3($a, $b) //date
{
	if ( count($a['use']) == count($b['use']) ) return 0;
	return ( count($a['use']) < count($b['use']) ) ? 1 : -1;
}

function uploads_sort_4($a, $b) //date
{
	if ( count($a['use']) == count($b['use']) ) return 0;
	return ( count($a['use']) > count($b['use']) ) ? 1 : -1;
}

function uploads_sort_5($a, $b) //date
{
	if ( $a['file'] == $b['file'] ) return 0;
	return ( $a['file'] < $b['file'] ) ? 1 : -1;
}

function uploads_sort_6($a, $b) //date
{
	if ( $a['file'] == $b['file'] ) return 0;
	return ( $a['file'] > $b['file'] ) ? 1 : -1;
}







?>