<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
 
// страница управления своими загрузками комюзером в личном кабинете
// проверка залогиненности и если нет - отправка на форму залогинивания  
$comuser = is_login_comuser();
if ($comuser)
{	
  $comusers_id = $comuser['comusers_id'];
  $error = false;
  
  if (!isset($options_template['user_uploads_title'])) $options_template['user_uploads_title'] = true;
  if (!isset($options_template['profile_title'])) $options_template['profile_title'] = 'Личный кабинет';  
  if (!isset($options_template['uploads_title'])) $options_template['uploads_title'] = 'Управление загрузками';  
  
  
  // для компонента хлебных крошек
  $breadcrumbs2 = '<a class="i-angle-right mar10-l" href="' . getinfo('siteurl') . $profile_slug . '">' . $options_template['profile_title'] . '</a>';
  $breadcrumbs3 = '<span class="i-angle-right mar10-l bold">' . $options_template['uploads_title'] . '</span>';
  
  require(getinfo('shared_dir') . 'main/main-start.php');
  echo NR . '<div class="type type_users_form">' . NR;

  // заголовок 
  if ($options_template['user_uploads_title']) echo '<H3>' . $options_template['profile_title'] . ' - ' . $options_template['uploads_title'] . '</H3>';
  
  
  // пытаемся взять файл меню личного кабинета из плагина profile	  
  $menu_file = getinfo('plugins_dir') . 'profile/priv_pages/menu.php'; 
  if (file_exists($menu_file)) require ($menu_file); 
  

  // вставим загрузчик файлов
  require (getinfo('plugins_dir') . 'comuser_uploader/manager-uploads.php'); 

  echo '<span class="my_files"><a href="' . getinfo('siteurl') . $profiles_slug . '/' . $comusers_id . '/' . $uploads_slug . '" title="Как страницу ваших файлов другие пользователи">Публичная страница загрузок>></a></span>';  

  
  echo NR . '</div><!-- class="type type_users_form" -->' . NR;
  require(getinfo('shared_dir') . 'main/main-end.php');
}
else
{
  require( getinfo('plugins_dir') . 'comuser_uploader/not_login.php' ); // подключили страницу-заглушку
}	

?>